// PAGEIIC.cpp : implementation file
//
#include "stdafx.h"
#include "resource.h"
#include "PAGEIIC.h"
#include "Susi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPAGEIIC property page

IMPLEMENT_DYNCREATE(CPAGEIIC, CPropertyPage)

CPAGEIIC::CPAGEIIC() : CPropertyPage(CPAGEIIC::IDD)
{
	//{{AFX_DATA_INIT(CPAGEIIC)
	m_REGOFFSET = _T("");
	m_RESULT = _T("");
	m_SADDR = _T("");
	//}}AFX_DATA_INIT
}

CPAGEIIC::~CPAGEIIC()
{
}

void CPAGEIIC::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPAGEIIC)
	DDX_Control(pDX, IDC_WRITEBYTE, m_WrBYTE);
	DDX_Control(pDX, IDC_READBYTE, m_RdBYTE);
	DDX_Text(pDX, IDC_REGOFFSET, m_REGOFFSET);
	DDX_Text(pDX, IDC_RESULT, m_RESULT);
	DDX_Text(pDX, IDC_SADDR, m_SADDR);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPAGEIIC, CPropertyPage)
	//{{AFX_MSG_MAP(CPAGEIIC)
	ON_BN_CLICKED(IDC_READBYTE, OnReadbyte)
	ON_BN_CLICKED(IDC_WRITEBYTE, OnWritebyte)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPAGEIIC message handlers

void CPAGEIIC::OnReadbyte() 
{
	// TODO: Add your control notification handler code here
	
	BYTE Address, Register, Result=0;
	TCHAR *p;
	UpdateData(TRUE);
	m_RESULT = _T("");

	Address = (BYTE)_tcstol(m_SADDR, &p, 16);
	Register = (BYTE)_tcstol(m_REGOFFSET, &p, 16);

	// Read data from the device through IIC
	if(!SusiIICAvailable()){
		AfxMessageBox(_T("This platform don't support IIC Write Byte"));
	
	}else if(!SusiIICReadByte(Address, Register, &Result)){
		AfxMessageBox(_T("IIC Read Byte failed"));
	
	}else{
		
		TCHAR temp[3];
		CString output;

		_itot(Result, temp, 16);
		output = _T("0x");
		output.Insert(output.GetLength(), temp);
		m_RESULT = m_RESULT + output;

		UpdateData(FALSE);
	}	
}

void CPAGEIIC::OnWritebyte() 
{
	// TODO: Add your control notification handler code here
	BYTE Address, Register, Result;
	TCHAR *p;
	UpdateData(TRUE);

	Address = (BYTE)_tcstol(m_SADDR, &p, 16);
	Register = (BYTE)_tcstol(m_REGOFFSET, &p, 16);
	Result = (BYTE)_tcstol(m_RESULT, &p, 16);

	// Write data to the device through IIC
	if(!SusiIICAvailable())
	{
		AfxMessageBox(_T("This platform don't support IIC Write Byte"));
	}
	else if(!SusiIICWriteByte(Address, Register, Result))
	{
		AfxMessageBox(_T("IIC Write Byte failed"));
	}
}
