#if !defined(AFX_PAGEGPIO_H__FD1394A6_5ACE_4A94_96B9_49180DE8823E__INCLUDED_)
#define AFX_PAGEGPIO_H__FD1394A6_5ACE_4A94_96B9_49180DE8823E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
/*++

Copyright (c) Advantech Co., Ltd. All Rights Reserved


File Name:
	PAGEGPIO.h

Abstract:
	Header file for the tab page GPIO
	

Revision History:
---------------------------------------------
	May 18, 2006	Change to Susi v1.0

---------------------------------------------
	June 22, 2005	First release
	
---------------------------------------------

Programmers:
	Baker  Chang

--*/

/////////////////////////////////////////////////////////////////////////////
// CPAGEGPIO dialog

class CPAGEGPIO : public CPropertyPage
{
	DECLARE_DYNCREATE(CPAGEGPIO)

// Construction
public:
	CPAGEGPIO();
	~CPAGEGPIO();

// Dialog Data
	//{{AFX_DATA(CPAGEGPIO)
	enum { IDD = IDD_PAGEGPIO };
	CEdit	m_GPIO_SinglePinNumCtrl;
	CButton	m_GPIO_WriteCtrl;
	CButton	m_GPIO_ReadCtrl;
	CEdit	m_GPIO_MultiPinNumCtrl;
	CString	m_GPIO_Result;
	CString	m_GPIO_MultiPinNum;
	int		m_GPIOMODE;
	BYTE	m_GPIO_SinglePinNum;
	int		m_GPIO_INUM;
	int		m_GPIO_OUTNUM;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPAGEGPIO)
	
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPAGEGPIO)
	afx_msg void OnRead();
	afx_msg void OnRadSinglePin();
	afx_msg void OnRadMultiPin();
	afx_msg void OnWrite();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	virtual BOOL OnInitDialog();
	virtual void OnOK();
	virtual void OnCancel();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGEGPIO_H__FD1394A6_5ACE_4A94_96B9_49180DE8823E__INCLUDED_)
