// PAGEHWM.cpp : implementation file
//

#include "stdafx.h"
#include "SusiDEMO.h"
#include "PAGEHWM.h"
#include "Susi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define CenTemp	1
#define FahTemp	2
#define	HWMTimer 130

/////////////////////////////////////////////////////////////////////////////
// CPAGEHWM property page

IMPLEMENT_DYNCREATE(CPAGEHWM, CPropertyPage)

CPAGEHWM::CPAGEHWM() : CPropertyPage(CPAGEHWM::IDD)
{
	//{{AFX_DATA_INIT(CPAGEHWM)
	//}}AFX_DATA_INIT
}

CPAGEHWM::~CPAGEHWM()
{
}

void CPAGEHWM::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPAGEHWM)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPAGEHWM, CPropertyPage)
	//{{AFX_MSG_MAP(CPAGEHWM)
	ON_BN_CLICKED(IDC_TEMPUNIT_CEN, OnTempunitCen)
	ON_BN_CLICKED(IDC_TEMPUNIT_FAH, OnTempunitFah)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPAGEHWM message handlers

BOOL CPAGEHWM::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	GetVoltage();
	GetTemperature();
	GetFanSpeed();

	this->SetTimer(HWMTimer,1000,NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CPAGEHWM::OnCancel() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(!SusiUnInit())
		AfxMessageBox(_T("Susi uninitialize failed !"));
	
	CPropertyPage::OnCancel();
}

void CPAGEHWM::OnOK() 
{
	// TODO: Add your specialized code here and/or call the base class
	if(!SusiUnInit())
		AfxMessageBox(_T("Susi uninitialize failed !"));

	CPropertyPage::OnOK();
}

void CPAGEHWM::GetVoltage() 
{
	// TODO: Add your specialized code here and/or call the base class
	float retval;
	
	//VCORE
	if(!SusiHWMGetVoltage(VCORE, &retval))
	{
		m_LABEL_VCORECtrl.EnableWindow(true);
		m_VCORECtrl.EnableWindow(true);
		m_VCORE.Format("%.2f", retval);

	}else{
		m_VCORE= _T("0");
		m_VCORECtrl.EnableWindow(false);
		m_LABEL_VCORECtrl.EnableWindow(false);	
	}
	
	// 2.5V
	if(!SusiHWMGetVoltage(V25, &retval))
	{
		m_LABEL_V25Ctrl.EnableWindow(true);
		m_V25Ctrl.EnableWindow(true);
		m_V25.Format("%.2f", retval);
	}else{
		m_V25= _T("0");
		m_V25Ctrl.EnableWindow(false);
		m_LABEL_V25Ctrl.EnableWindow(false);
	}
	
	// 3.3V
	if(!SusiHWMGetVoltage(V33, &retval))
	{
		m_LABEL_V33Ctrl.EnableWindow(true);
		m_V33Ctrl.EnableWindow(true);
		m_V33.Format("%.2f", retval);
	}else{
		m_V33= _T("0");
		m_V33Ctrl.EnableWindow(false);
		m_LABEL_V33Ctrl.EnableWindow(false);
	}
	
	// 5.0V
	if(!SusiHWMGetVoltage(V50, &retval))
	{
		m_LABEL_V50Ctrl.EnableWindow(true);
		m_V50Ctrl.EnableWindow(true);
		m_V50.Format("%.2f", retval);
	}else{
		m_V50= _T("0");
		m_V50Ctrl.EnableWindow(false);
		m_LABEL_V50Ctrl.EnableWindow(false);
	}
	
	// 12V
	if(!SusiHWMGetVoltage(V120, &retval))
	{
		m_LABEL_V120Ctrl.EnableWindow(true);
		m_V120Ctrl.EnableWindow(true);
		m_V120.Format("%.2f", retval);
	}else{
		m_V120= _T("0");
		m_V120Ctrl.EnableWindow(false);
		m_LABEL_V120Ctrl.EnableWindow(false);
	}
	
	// -5V
	if(!SusiHWMGetVoltage(VN50, &retval))
	{
		m_LABEL_VN50Ctrl.EnableWindow(true);
		m_VN50Ctrl.EnableWindow(true);
		m_VN50.Format("%.2f", retval);
	}else{
		m_VN50= _T("0");
		m_VN50Ctrl.EnableWindow(false);
		m_LABEL_VN50Ctrl.EnableWindow(false);
	}

	// -12V
	if(!SusiHWMGetVoltage(VN120, &retval))
	{
		m_LABEL_VN120Ctrl.EnableWindow(true);
		m_VN120Ctrl.EnableWindow(true);
		m_VN120.Format("%.2f", retval);
	}else{
		m_VN120= _T("0");
		m_VN120Ctrl.EnableWindow(false);
		m_LABEL_VN120Ctrl.EnableWindow(false);
	}

	// VBAT
	if(!SusiHWMGetVoltage(VBAT, &retval))
	{
		m_LABEL_VBATCtrl.EnableWindow(true);
		m_VBATCtrl.EnableWindow(true);
		m_VBAT.Format("%.2f", retval);
	}else{
		m_VBAT= _T("0");
		m_VBATCtrl.EnableWindow(false);
		m_LABEL_VBATCtrl.EnableWindow(false);
	}

	// 5VSB
	if(!SusiHWMGetVoltage(VSB, &retval))
	{
		m_LABEL_VSBCtrl.EnableWindow(true);
		m_VSBCtrl.EnableWindow(true);
		m_VSB.Format("%.2f", retval);
	}else{
		m_VSB= _T("0");
		m_VSBCtrl.EnableWindow(false);
		m_LABEL_VSBCtrl.EnableWindow(false);
	}

	// VTT
	if(!SusiHWMGetVoltage(VTT, &retval))
	{
		m_LABEL_VTTCtrl.EnableWindow(true);
		m_VTTCtrl.EnableWindow(true);
		m_VTT.Format("%.2f", retval);
	}else{
		m_VTT= _T("0");
		m_VTTCtrl.EnableWindow(false);
		m_LABEL_VTTCtrl.EnableWindow(false);
	}

	UpdateData(FALSE);
}

void CPAGEHWM::GetTemperature() 
{
	// TODO: Add your specialized code here and/or call the base class
	float retval;

	// CPU temperature
	if(!SusiHWMGetTemperature(TCPU, &retval))
	{
		m_LABEL_CPUTEMPCtrl.EnableWindow(true);
		m_TEMP_CPUCtrl.EnableWindow(true);
		m_TEMP_CPU.Format("%.2f", retval);

		m_LOWTEMP_CPU = atoi(m_TEMP_CPU) - 5;
		m_HIGHTEMP_CPU = atoi(m_TEMP_CPU) + 5;

	}else{
		m_TEMP_CPU= _T("0");
		m_TEMP_CPUCtrl.EnableWindow(false);
		m_LABEL_CPUTEMPCtrl.EnableWindow(false);
	}

	// System temperature
	if(!SusiHWMGetTemperature(TSYS, &retval))
	{
		m_LABEL_SYSTEMPCtrl.EnableWindow(true);
		m_TEMP_SYSCtrl.EnableWindow(true);
		m_TEMP_SYS.Format("%.2f", retval);

		m_LOWTEMP_SYS = atoi(m_TEMP_SYS) - 5;
		m_HIGHTEMP_SYS = atoi(m_TEMP_SYS) + 5;

	}else{
		m_TEMP_SYS= _T("0");
		m_TEMP_SYSCtrl.EnableWindow(false);
		m_LABEL_SYSTEMPCtrl.EnableWindow(false);
	}

	UpdateData(FALSE);
}

void CPAGEHWM::GetFanSpeed() 
{
	// TODO: Add your specialized code here and/or call the base class
	WORD retval;
	
	// CPU Fan Speed
	if(!SusiHWMGetFanSpeed(FCPU, &retval))
	{
		m_LABEL_CPUFANCtrl.EnableWindow(true);
		m_FAN_CPUCtrl.EnableWindow(true);
		m_FAN_CPU.Format("%d", retval);
	}else{
		m_FAN_CPU= _T("0");
		m_FAN_CPUCtrl.EnableWindow(false);
		m_LABEL_CPUFANCtrl.EnableWindow(false);
	}

	// System Fan Speed
	if(!SusiHWMGetFanSpeed(FSYS, &retval))
	{
		m_LABEL_SYSFANCtrl.EnableWindow(true);
		m_FAN_SYSCtrl.EnableWindow(true);
		m_FAN_SYS.Format("%d", retval);
	}else{
		m_FAN_SYS= _T("0");
		m_FAN_SYSCtrl.EnableWindow(false);
		m_LABEL_SYSFANCtrl.EnableWindow(false);
	}

	// The 2nd Fan Speed
	if(!SusiHWMGetFanSpeed(F2ND, &retval))
	{
		m_LABEL_2NDFANCtrl.EnableWindow(true);
		m_FAN_2NDCtrl.EnableWindow(true);
		m_FAN_2ND.Format("%d", retval);
	}else{
		m_FAN_2ND= _T("0");
		m_FAN_2NDCtrl.EnableWindow(false);
		m_LABEL_2NDFANCtrl.EnableWindow(false);
	}

	UpdateData(FALSE);
}

void CPAGEHWM::OnTempunitCen() 
{
	// TODO: Add your control notification handler code here
	if(m_TEMPUNIT == 1)
	{
		TranTempUnit(CenTemp);
		UpdateData(FALSE);
	}
	
}

void CPAGEHWM::OnTempunitFah() 
{
	// TODO: Add your control notification handler code here
	if(m_TEMPUNIT == 0)
	{
		TranTempUnit(FahTemp);
		UpdateData(FALSE);
	}
	
}

void CPAGEHWM::OnTimer(UINT nIDEvent) 
{
	// TODO: Add your message handler code here and/or call default

	GetVoltage();
	GetTemperature();
	GetFanSpeed();

	// Transfer temperature unit
	if(m_TEMPUNIT == 1) 
	{
		TranTempUnit(FahTemp);
		UpdateData(FALSE);
	}

	if(m_LOWTEMP_CPU && atol(m_TEMP_CPU) <= m_LOWTEMP_CPU)
		AfxMessageBox(_T("CPU temperature is too low!"));

	else if(m_HIGHTEMP_CPU && atol(m_TEMP_CPU) >= m_HIGHTEMP_CPU)
		AfxMessageBox(_T("CPU temperature is too high!"));

	if(m_LOWTEMP_SYS && atol(m_TEMP_SYS) <= m_LOWTEMP_SYS)
		AfxMessageBox(_T("System temperature is too low!"));

	else if(m_HIGHTEMP_SYS && atol(m_TEMP_SYS) >= m_HIGHTEMP_SYS)
		AfxMessageBox(_T("System temperature is too high!"));

	
	CPropertyPage::OnTimer(nIDEvent);
}

void CPAGEHWM::TranTempUnit(BYTE bTempUnit) 
{
	switch(bTempUnit)
	{
	case CenTemp:

		double tempC;

		tempC = (atof(m_TEMP_CPU) - 32) * 5/9;
		m_TEMP_CPU.Format("%.2f", tempC);

		tempC = (atof(m_TEMP_SYS) - 32) * 5/9;
		m_TEMP_SYS.Format("%.2f", tempC);

		m_TEMPUNIT_CPU = _T("C");
		m_TEMPUNIT_SYS = _T("C");

		m_TEMPUNIT = 0;

		break;

	case FahTemp:

		//if(m_TEMPUNIT == 1) break;

		double tempF;

		tempF = atof(m_TEMP_CPU) * 9/5 + 32;
		m_TEMP_CPU.Format("%.2f", tempF);

		tempF = atof(m_TEMP_SYS) * 9/5 + 32;
		m_TEMP_SYS.Format("%.2f", tempF);

		m_TEMPUNIT_CPU = _T("F");
		m_TEMPUNIT_SYS = _T("F");

		m_TEMPUNIT = 1;

		break;

	default:
		break;
	}

}
