// PAGEHWMNEW.cpp : implementation file
//

#include "stdafx.h"
#include "SusiDEMO.h"
#include "PAGEHWMNEW.h"
#include "Susi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString text;
/////////////////////////////////////////////////////////////////////////////
// CPAGEHWMNEW property page

IMPLEMENT_DYNCREATE(CPAGEHWMNEW, CPropertyPage)

CPAGEHWMNEW::CPAGEHWMNEW() : CPropertyPage(CPAGEHWMNEW::IDD)
{
	//{{AFX_DATA_INIT(CPAGEHWMNEW)
	m_flV120 = 0.0f;
	m_flV25 = 0.0f;
	m_flV33 = 0.0f;
	m_flV50 = 0.0f;
	m_flVBAT = 0.0f;
	m_flVCORE = 0.0f;
	m_flVN120 = 0.0f;
	m_flVN50 = 0.0f;
	m_flVSB = 0.0f;
	m_flVTT = 0.0f;
	m_flTCPU = 0.0f;
	m_flTSYS = 0.0f;
	m_wFCPU = 0;
	m_wFOTHER = 0;
	m_wFSYS = 0;
	m_dwVoltSupport = 0;
	m_wTempSupport = 0;
	m_wFanSupport = 0;	
	*(m_flVolt+0) = &m_flVCORE;
	*(m_flVolt+1) = &m_flV25;
	*(m_flVolt+2) = &m_flV33;
	*(m_flVolt+3) = &m_flV50;
	*(m_flVolt+4) = &m_flV120;
	*(m_flVolt+5) = &m_flVSB;
	*(m_flVolt+6) = &m_flVBAT;
	*(m_flVolt+7) = &m_flVN50;
	*(m_flVolt+8) = &m_flVN120;
	*(m_flVolt+9) = &m_flVTT;	
	*(m_flTemp+0) = &m_flTCPU;
	*(m_flTemp+1) = &m_flTSYS;	
	*(m_wFan+0) = &m_wFCPU;
	*(m_wFan+1) = &m_wFSYS;
	*(m_wFan+2) = &m_wFOTHER;
	//}}AFX_DATA_INIT
}

CPAGEHWMNEW::~CPAGEHWMNEW()
{
}

void CPAGEHWMNEW::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPAGEHWMNEW)
	DDX_Text(pDX, IDC_EDIT_V120, m_flV120);
	DDX_Text(pDX, IDC_EDIT_V25, m_flV25);
	DDX_Text(pDX, IDC_EDIT_V33, m_flV33);
	DDX_Text(pDX, IDC_EDIT_V50, m_flV50);
	DDX_Text(pDX, IDC_EDIT_VBAT, m_flVBAT);
	DDX_Text(pDX, IDC_EDIT_VCORE, m_flVCORE);
	DDX_Text(pDX, IDC_EDIT_VN120, m_flVN120);
	DDX_Text(pDX, IDC_EDIT_VN50, m_flVN50);
	DDX_Text(pDX, IDC_EDIT_VSB, m_flVSB);
	DDX_Text(pDX, IDC_EDIT_VTT, m_flVTT);
	DDX_Text(pDX, IDC_EDIT_TEMP_CPU, m_flTCPU);
	DDX_Text(pDX, IDC_EDIT_TEMP_SYS, m_flTSYS);
	DDX_Text(pDX, IDC_EDIT_FAN_CPU, m_wFCPU);
	DDX_Text(pDX, IDC_EDIT_FAN_OTHER, m_wFOTHER);
	DDX_Text(pDX, IDC_EDIT_FAN_SYS, m_wFSYS);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPAGEHWMNEW, CPropertyPage)
	//{{AFX_MSG_MAP(CPAGEHWMNEW)
	ON_BN_CLICKED(IDC_BUTTON_MONITOR, OnButtonMonitor)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPAGEHWMNEW message handlers

BOOL CPAGEHWMNEW::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();
	
	// TODO: Add extra initialization here
	if(SusiHWMGetVoltage(0,0, &m_dwVoltSupport)<0)
	{
		AfxMessageBox(_T("H/W monitor get voltage fail"));
		return FALSE;
	}
	//text.Format(_T("m_dwVoltSupport = 0x%x\n"), m_dwVoltSupport);
	//AfxMessageBox(text);
	
	GetDlgItem(IDC_EDIT_VCORE)->EnableWindow((m_dwVoltSupport&VCORE)>0);
	GetDlgItem(IDC_EDIT_V25)->EnableWindow((m_dwVoltSupport&V25)>0);
	GetDlgItem(IDC_EDIT_V33)->EnableWindow((m_dwVoltSupport&V33)>0);
	GetDlgItem(IDC_EDIT_V50)->EnableWindow((m_dwVoltSupport&V50)>0);
	GetDlgItem(IDC_EDIT_V120)->EnableWindow((m_dwVoltSupport&V120)>0);
	GetDlgItem(IDC_EDIT_VSB)->EnableWindow((m_dwVoltSupport&VSB)>0);
	GetDlgItem(IDC_EDIT_VBAT)->EnableWindow((m_dwVoltSupport&VBAT)>0);
	GetDlgItem(IDC_EDIT_VN50)->EnableWindow((m_dwVoltSupport&VN50)>0);
	GetDlgItem(IDC_EDIT_VN120)->EnableWindow((m_dwVoltSupport&VN120)>0);
	GetDlgItem(IDC_EDIT_VTT)->EnableWindow((m_dwVoltSupport&VTT)>0);
	
	if(SusiHWMGetTemperature(0,0, &m_wTempSupport)<0)
	{
		AfxMessageBox(_T("H/W monitor get temperature fail"));
		return FALSE;
	}
	GetDlgItem(IDC_EDIT_TEMP_CPU)->EnableWindow((m_wTempSupport&TCPU)>0);
	GetDlgItem(IDC_EDIT_TEMP_SYS)->EnableWindow((m_wTempSupport&TSYS)>0);
	
	if(SusiHWMGetFanSpeed(0,0, &m_wFanSupport)<0)
	{
		AfxMessageBox(_T("H/W monitor get fan speed fail"));
		return FALSE;
	}
	GetDlgItem(IDC_EDIT_FAN_CPU)->EnableWindow((m_wFanSupport&FCPU)>0);
	GetDlgItem(IDC_EDIT_FAN_SYS)->EnableWindow((m_wFanSupport&FSYS)>0);
	GetDlgItem(IDC_EDIT_FAN_OTHER)->EnableWindow((m_wFanSupport&F2ND)>0);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

DWORD WINAPI CPAGEHWMNEW::ThreadProcHWM(LPVOID lpArg)
{
	CPAGEHWMNEW* pThis = reinterpret_cast<CPAGEHWMNEW*>(lpArg);
	float volt, temp;
	WORD fan;
	
	do {
		//if (pThis->m_fThreadHWMStop==FALSE)
		{
			
			for (int l=0,i=1; i<(1<<10); i<<=1)
			{
				if(i&pThis->m_dwVoltSupport)
				{
					if(SusiHWMGetVoltage(i, &volt)<0)
					{
						AfxMessageBox(_T("H/W monitor get voltage fail"));
						return 0;
					}
					**(pThis->m_flVolt+l) = volt;
					
						
				}
				else  //not support
				{
					//**(m_flVolt+l) = 0;
				}
				l++;
			}
			
			for (int m=0,j=1; j<(1<<2); j<<=1)
			{
				if(j&pThis->m_wTempSupport)
				{
					if(SusiHWMGetTemperature(j, &temp)<0)
					{
						AfxMessageBox(_T("H/W monitor get temperature fail"));
						return 0;
					}
					**(pThis->m_flTemp+m) = temp;
					
						
				}
				else  //not support
				{
					//**(m_flTemp+m) = 0;
				}
				m++;
			}
			
			for (int n=0,k=1; k<(1<<3); k<<=1)
			{
				if(k&pThis->m_wFanSupport)
				{
					if(SusiHWMGetFanSpeed(k, &fan)<0)
					{
						AfxMessageBox(_T("H/W monitor get fan speed fail"));
						return 0;
					}
					**(pThis->m_wFan+n) = fan;
					
						
				}
				else  //not support
				{
					//**(m_wFan+n) = 0;
				}
				n++;
			}
			
			pThis->UpdateData(FALSE);
			Sleep(500);
		}
	}while(1); //while(pThis->m_fThreadHWMStop==FALSE);
	
	return 0;
}

void CPAGEHWMNEW::OnButtonMonitor() 
{
	// TODO: Add your control notification handler code here
	m_fStartMonitor = !m_fStartMonitor;
	if(m_fStartMonitor){
		DWORD dwThreadId = 0;
		m_hThreadHWM = CreateThread(0,0,(LPTHREAD_START_ROUTINE)ThreadProcHWM,LPVOID(this),0,&dwThreadId);
		if (m_hThreadHWM == 0){
			AfxMessageBox(_T("Start H/W monitoring thread fail"));	
			return;
		}

		GetDlgItem(IDC_BUTTON_MONITOR)->SetWindowText(_T("Stop"));
	}
	else{
		if (m_hThreadHWM)
		{
			/*
			// Set the flag that the thread must be stopped
			m_fThreadHWMStop = TRUE;		
		
			// Wait until the thread has stopped
			::WaitForSingleObject(m_hThreadHWM, INFINITE);

			// The thread has stopped
			m_fThreadHWMStop = FALSE;

			// Close handle to the thread
			::CloseHandle(m_hThreadHWM);
			m_hThreadHWM = 0;
			*/
			TerminateThread(m_hThreadHWM ,0);
			m_hThreadHWM = 0;
		}
		GetDlgItem(IDC_BUTTON_MONITOR)->SetWindowText(_T("Monitor"));
	}	

	
}
