#if !defined(AFX_PAGEVCTRL_H__417530EA_6D4A_4CFB_A029_69AC6658B90E__INCLUDED_)
#define AFX_PAGEVCTRL_H__417530EA_6D4A_4CFB_A029_69AC6658B90E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*++

Copyright (c) Advantech Co., Ltd. All Rights Reserved


File Name:
	PAGEVCTRL.h

Abstract:
	Header file for the tab page VGA CONTROL
	

Revision History:
---------------------------------------------
	May 18, 2006	Change to Susi v1.0

---------------------------------------------
	June 22, 2005	First release
	
---------------------------------------------

Programmers:
	Baker  Chang

--*/

/////////////////////////////////////////////////////////////////////////////
// CPAGEVCTRL dialog

class CPAGEVCTRL : public CPropertyPage
{
	DECLARE_DYNCREATE(CPAGEVCTRL)

// Construction
public:
	CPAGEVCTRL();
	~CPAGEVCTRL();
	BOOL PreTranslateMessage(MSG* pMsg);	// For Hotkey

// Dialog Data
	//{{AFX_DATA(CPAGEVCTRL)
	enum { IDD = IDD_PAGEVCTRL };
	CButton	m_RAD_VGASwitchCtrl;
	CSliderCtrl	m_BRIGSLIDER_CTRL;
	CButton	m_BRIGHTUP;
	CButton	m_BRIGDOWN;
	int		m_RAD_VGASwitch;
	int		m_BRIGSLIDER_VAL;
	int		m_BRIGHTVAL;
	//}}AFX_DATA

// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPAGEVCTRL)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPAGEVCTRL)
	afx_msg void OnRadVgaon();
	afx_msg void OnRadVgaoff();
	afx_msg void OnBrigup();
	afx_msg void OnBrigdown();
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	virtual void OnOK();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGEVCTRL_H__417530EA_6D4A_4CFB_A029_69AC6658B90E__INCLUDED_)
