#if !defined(AFX_PAGEWDT_H__F6FD7913_74CC_4571_AB5F_D2DD764AD5F4__INCLUDED_)
#define AFX_PAGEWDT_H__F6FD7913_74CC_4571_AB5F_D2DD764AD5F4__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*++

Copyright (c) Advantech Co., Ltd. All Rights Reserved


File Name:
	PAGEWDT.h

Abstract:
	Header file for the tab page WATCHDOG
	

Revision History:
---------------------------------------------
	May 18, 2006	Change to Susi v1.0

---------------------------------------------
	June 22, 2005	First release
	
---------------------------------------------

Programmers:
	Baker  Chang

--*/

/////////////////////////////////////////////////////////////////////////////
// CPAGEWDT dialog

class CPAGEWDT : public CPropertyPage
{
	DECLARE_DYNCREATE(CPAGEWDT)

// Construction
public:
	CPAGEWDT();
	~CPAGEWDT();

// Dialog Data
	//{{AFX_DATA(CPAGEWDT)
	enum { IDD = IDD_PAGEWDT };
	CEdit	m_WDTDELAYCTRL;
	CEdit	m_WDTMOUTCTRL;
	CButton	m_WDTSTOP;
	CButton	m_WDTSTART;
	CButton	m_WDTREF;
	int		m_WDTCDOWN;
	int		m_WDTDELAY;
	int		m_WDTMOUT;
	DWORD	m_WDTMAX;
	DWORD	m_WDTMIN;
	DWORD	m_WDTSTEP;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPAGEWDT)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
	
protected:
	// Generated message map functions
	//{{AFX_MSG(CPAGEWDT)
	afx_msg void OnStart();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnRefresh();
	afx_msg void OnStop();
	afx_msg void OnAltwdt();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	virtual void OnOK();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGEWDT_H__F6FD7913_74CC_4571_AB5F_D2DD764AD5F4__INCLUDED_)
