#if !defined(AFX_PAGEHWMNEW_H__597B47BE_70C8_432E_A6A5_03CD1363B40E__INCLUDED_)
#define AFX_PAGEHWMNEW_H__597B47BE_70C8_432E_A6A5_03CD1363B40E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PAGEHWMNEW.h : header file
//

#define VCORE	(1<<0)	// Vcore
#define V25		(1<<1)	// 2.5V
#define V33		(1<<2)	// 3.3V
#define V50		(1<<3)	// 5V
#define V120	(1<<4)	// 12V
#define VSB		(1<<5)	// Voltage of standby
#define VBAT	(1<<6)	// VBAT
#define VN50	(1<<7)	// -5V
#define VN120	(1<<8)	// -12V
#define VTT		(1<<9)	// VTT

// Temperature
#define TCPU	(1<<0)	// CPU temperature
#define TSYS	(1<<1)	// System temperature

// Fan Speed
#define FCPU	(1<<0)	// CPU FAN Speed
#define FSYS	(1<<1)	// System FAN Speed
#define F2ND	(1<<2)	// Other FAN Speed
/////////////////////////////////////////////////////////////////////////////
// CPAGEHWMNEW dialog

class CPAGEHWMNEW : public CPropertyPage
{
	DECLARE_DYNCREATE(CPAGEHWMNEW)

// Construction
public:
	CPAGEHWMNEW();
	~CPAGEHWMNEW();

// Dialog Data
	//{{AFX_DATA(CPAGEHWMNEW)
	enum { IDD = IDD_PAGEHWM };
	float	m_flV120;
	float	m_flV25;
	float	m_flV33;
	float	m_flV50;
	float	m_flVBAT;
	float	m_flVCORE;
	float	m_flVN120;
	float	m_flVN50;
	float	m_flVSB;
	float	m_flVTT;
	float	m_flTCPU;
	float	m_flTSYS;
	UINT	m_wFCPU;
	UINT	m_wFOTHER;
	UINT	m_wFSYS;
	DWORD m_dwVoltSupport;
	WORD m_wTempSupport;
	WORD m_wFanSupport;
	float* m_flVolt[10];
	float* m_flTemp[2];
	UINT* m_wFan[3];
	//}}AFX_DATA
	static DWORD WINAPI ThreadProcHWM(LPVOID lpArg);


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPAGEHWMNEW)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPAGEHWMNEW)
	virtual BOOL OnInitDialog();
	afx_msg void OnButtonMonitor();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	BOOL m_fStartMonitor;
	BOOL m_fThreadHWMStop;
	HANDLE m_hThreadHWM;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGEHWMNEW_H__597B47BE_70C8_432E_A6A5_03CD1363B40E__INCLUDED_)
