#if !defined(AFX_PAGESMBUS_H__973E6396_B4B7_4746_B3AB_EB579CBFD62D__INCLUDED_)
#define AFX_PAGESMBUS_H__973E6396_B4B7_4746_B3AB_EB579CBFD62D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/*++

Copyright (c) Advantech Co., Ltd. All Rights Reserved


File Name:
	PAGESMBUS.h

Abstract:
	Header file for the tab page SMBus
	

Revision History:
---------------------------------------------
	May 18, 2006	Change to Susi v1.0

---------------------------------------------
	June 22, 2005	First release
	
---------------------------------------------

Programmers:
	Baker  Chang

--*/

/////////////////////////////////////////////////////////////////////////////
// CPAGESMBUS dialog

class CPAGESMBUS : public CPropertyPage
{
	DECLARE_DYNCREATE(CPAGESMBUS)

// Construction
public:
	CPAGESMBUS();
	~CPAGESMBUS();

// Dialog Data
	//{{AFX_DATA(CPAGESMBUS)
	enum { IDD = IDD_PAGESMBUS };
	CEdit	m_BYTENUMCTRL;
	CButton	m_READ;
	CButton	m_WRITE;
	BYTE	m_BYTENUM;
	CString	m_REGOFFSET;
	CString	m_SADDR;
	CString	m_RESULT;
	int		m_AccMode;
	//}}AFX_DATA


// Overrides
	// ClassWizard generate virtual function overrides
	//{{AFX_VIRTUAL(CPAGESMBUS)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	// Generated message map functions
	//{{AFX_MSG(CPAGESMBUS)
	afx_msg void OnRadByte();
	afx_msg void OnRadMultibyte();
	afx_msg void OnRadWord();
	afx_msg void OnRead();
	afx_msg void OnWrite();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
	
	virtual BOOL OnInitDialog();
	virtual void OnCancel();
	virtual void OnOK();

	void ReadByteMode();
	void ReadMultiByteMode();
	void ReadWordMode();
	
	void WriteByteMode();
	void WriteMultiByteMode();
	void WriteWordMode();

};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PAGESMBUS_H__973E6396_B4B7_4746_B3AB_EB579CBFD62D__INCLUDED_)
